// To parse this JSON data, do
//
//     final userListModel = userListModelFromJson(jsonString);

import 'dart:convert';

import 'package:get/get.dart';

UserListModel userListModelFromJson( str) => UserListModel.fromJson(str);

String userListModelToJson(UserListModel data) => json.encode(data.toJson());

class UserListModel {
  var isSuccess;
  List<UserList>? list;

  UserListModel({
    this.isSuccess,
    this.list,
  });

  factory UserListModel.fromJson(Map<String, dynamic> json) => UserListModel(
    isSuccess: json["isSuccess"],
    list: json["list"] == null ? [] : List<UserList>.from(json["list"]!.map((x) => UserList.fromJson(x))),
  );

  Map<String, dynamic> toJson() => {
    "isSuccess": isSuccess,
    "list": list == null ? [] : List<dynamic>.from(list!.map((x) => x.toJson())),
  };
}

class UserList {
  String? clientId;
  DateTime? createdAt;
  String? email;
  String? fcmToken;
  String? firstName;
  var isActive;
  var isDeleted;
  String? lastName;
  String? name;
  String? phone;
  String? profilePicture;
  String? roleId;
  String? secretKey;
  DateTime? updatedAt;
  String? userId;
  String? username;
  var isSelected = false.obs;

  UserList({
    this.clientId,
    this.createdAt,
    this.email,
    this.fcmToken,
    this.firstName,
    this.isActive,
    this.isDeleted,
    this.lastName,
    this.name,
    this.phone,
    this.profilePicture,
    this.roleId,
    this.secretKey,
    this.updatedAt,
    this.userId,
    this.username,
  });

  factory UserList.fromJson(Map<String, dynamic> json) => UserList(

    clientId: json["clientId"],
    createdAt: json["createdAt"] == null ? null : DateTime.parse(json["createdAt"]),
    email: json["email"],
    fcmToken: json["fcmToken"],
    firstName: json["firstName"],
    isActive: json["isActive"],
    isDeleted: json["isDeleted"],
    lastName: json["lastName"],
    name: json["name"],
    phone: json["phone"],
    profilePicture: json["profilePicture"],
    roleId: json["roleId"],
    secretKey: json["secretKey"],
    updatedAt: json["updatedAt"] == null ? null : DateTime.parse(json["updatedAt"]),
    userId: json["userId"],
    username: json["username"],
  );

  Map<String, dynamic> toJson() => {
    "clientId": clientId,
    "createdAt": createdAt?.toIso8601String(),
    "email": email,
    "fcmToken": fcmToken,
    "firstName": firstName,
    "isActive": isActive,
    "isDeleted": isDeleted,
    "lastName": lastName,
    "name": name,
    "phone": phone,
    "profilePicture": profilePicture,
    "roleId": roleId,
    "secretKey": secretKey,
    "updatedAt": updatedAt?.toIso8601String(),
    "userId": userId,
    "username": username,
  };
}
