// To parse this JSON data, do
//
//     final groupListModel = groupListModelFromJson(jsonString);

import 'dart:convert';

List<GroupListModel> groupListModelFromJson(str) =>
    List<GroupListModel>.from(str.map((x) => GroupListModel.fromJson(x)));

String groupListModelToJson(List<GroupListModel> data) =>
    json.encode(List<dynamic>.from(data.map((x) => x.toJson())));

class GroupListModel {
  GroupListModel({
    this.imagePath,
    this.groupName,
    this.latestTime,
    this.unreadCount,
    this.msgType,
    this.recentMsg,
    this.isGroup,
    this.groupId,
    this.opponentUserId,
    this.isBlocked,
  });

  String? imagePath;
  String? groupName;
  LatestTime? latestTime;
  int? unreadCount;
  String? msgType;
  String? recentMsg;
  bool? isGroup;
  String? groupId;
  String? opponentUserId;
  int? isBlocked;

  factory GroupListModel.fromJson(Map<String, dynamic> json) => GroupListModel(
        imagePath: json["imagePath"],
        groupName: json["groupName"],
        latestTime: json["latestTime"] == null
            ? null
            : LatestTime.fromJson(json["latestTime"]),
        unreadCount: json["unreadCount"],
        msgType: json["msgType"].toString(),
        recentMsg: json["recentMsg"],
        isGroup: json["isGroup"],
        groupId: json["groupId"],
    isBlocked: json["isBlocked"],
        opponentUserId: json["opponentUserId"].toString(),
      );

  Map<String, dynamic> toJson() => {
        "imagePath": imagePath,
        "groupName": groupName,
        "latestTime": latestTime?.toJson(),
        "unreadCount": unreadCount,
        "msgType": msgType,
        "recentMsg": recentMsg,
        "isGroup": isGroup,
        "groupId": groupId,
        "isBlocked": isBlocked,
        "opponentUserId": opponentUserId,
      };
}

class LatestTime {
  LatestTime({
    this.seconds,
    this.nanoseconds,
  });

  int? seconds;
  int? nanoseconds;

  factory LatestTime.fromJson(Map<String, dynamic> json) => LatestTime(
        seconds: json["seconds"],
        nanoseconds: json["nanoseconds"],
      );

  Map<String, dynamic> toJson() => {
        "seconds": seconds,
        "nanoseconds": nanoseconds,
      };
}
